@applying_vouchers @javascript
Feature: Applying my vouchers
  In order to have a discount
  As a customer
  I want to be able to use my voucher

  Background:
    Given the store operates on a single channel in the "United States" named "usa"
    And there is a customer "Florian Merle" identified by an email "florian.merle@dedi-agency.com" and a password "florian"
    And the customer "florian.merle@dedi-agency.com" has a voucher with the following amount "25" and code "VOUCHER25" in the channel "usa"
    And the customer "florian.merle@dedi-agency.com" has a voucher with the following amount "100" and code "VOUCHER100" in the channel "usa"
    And I am logged in as "florian.merle@dedi-agency.com"
    And the store has a product "PHP T-Shirt" priced at "$30.00"
    And the store ships everywhere for free
    And the store allows paying offline

  @ui
  Scenario: Applying one voucher
    Given I have product "PHP T-Shirt" in the cart
    And I specified the billing address as "Ankh Morpork", "Frost Alley", "90210", "United States" for "Jon Snow"
    And I proceed with "Free" shipping method and "Offline" payment
    When I use my voucher with the code "VOUCHER25"
    Then The vouchers total should be equal to "$25.00"
    And The order total should be equal to "$5.00"

  @ui
  Scenario: Removing one voucher
    Given I have product "PHP T-Shirt" in the cart
    And I specified the billing address as "Ankh Morpork", "Frost Alley", "90210", "United States" for "Jon Snow"
    And I proceed with "Free" shipping method and "Offline" payment
    When I use my voucher with the code "VOUCHER25"
    Then The vouchers total should be equal to "$25.00"
    And The order total should be equal to "$5.00"
    When I remove my voucher with the code "VOUCHER25"
    Then The vouchers total should not be displayed
    And The order total should be equal to "$30.00"

  @ui
  Scenario: My voucher amount should change
    Given I have product "PHP T-Shirt" in the cart
    And I specified the billing address as "Ankh Morpork", "Frost Alley", "90210", "United States" for "Jon Snow"
    And I proceed with "Free" shipping method and "Offline" payment
    When I use my voucher with the code "VOUCHER100"
    Then The vouchers total should be equal to "$30.00"
    And The order total should be equal to "$0.00"
    And I complete the payment step
    And I confirm my order
    When I am on my voucher list
    Then I should see a voucher with the following amount "$70.00" and the initial amount "$100.00"
