<?php

declare(strict_types=1);

namespace Tests\Dedi\SyliusVoucherPlugin\Behat\Context\Ui\Shop;

use Behat\Behat\Context\Context;
use Tests\Dedi\SyliusVoucherPlugin\Behat\Page\Shop\IndexVoucherPage;
use Webmozart\Assert\Assert;

class ConsultingVoucherContext implements Context
{
    private IndexVoucherPage $indexVoucherPage;

    public function __construct(
        IndexVoucherPage $indexVoucherPage
    ) {
        $this->indexVoucherPage = $indexVoucherPage;
    }

    /**
     * @When I am on my voucher list
     */
    public function iAmOnMyVoucherList()
    {
        $this->indexVoucherPage->open();
    }

    /**
     * @Then I should see a voucher with the following amount :amount
     * @Then I should see a voucher with the following amount :amount and the initial amount :initialAmount
     */
    public function iShouldSeeAVoucherWithTheFollowingAmount($amount, $initialAmount = null)
    {
        Assert::true($this->indexVoucherPage->isVoucherWithAmountInTheList(
            $amount,
            $initialAmount ?? $amount
        ));
    }
}
