<?php

declare(strict_types=1);

namespace Tests\Dedi\SyliusVoucherPlugin\Behat\Page\Admin;

use Sylius\Behat\Page\Admin\Crud\CreatePage;

class CreateVoucherPage extends CreatePage implements CreateVoucherPageInterface
{
    public function setCustomerEmail($email)
    {
        $this->getElement('customer_search')->setValue($email);

        $this->getDriver()->executeScript(sprintf(
            "document.getElementById('dedi_sylius_voucher_voucher_customer').value = '%s'",
            $email
        ));
    }

    public function setAmount($amount)
    {
        $this->getElement('amount')->setValue($amount);
    }

    protected function getDefinedElements(): array
    {
        return array_merge(parent::getDefinedElements(), [
            'customer_search' => '.sylius-autocomplete .search',
            'amount' => '#dedi_sylius_voucher_voucher_initialAmount',
        ]);
    }
}
