<?php

declare(strict_types=1);

namespace Tests\Dedi\SyliusVoucherPlugin\Behat\Page\Shop;

use FriendsOfBehat\PageObjectExtension\Page\SymfonyPage;

class PaymentPage extends SymfonyPage implements PaymentPageInterface
{
    public function getRouteName(): string
    {
        return 'sylius_shop_checkout_select_payment';
    }

    public function applyVoucherWithId($id)
    {
        $this->getElement('voucher_radio')->setValue($id);

        $this->getElement('submit')->click();
    }

    public function isVoucherTotalEqualTo($total): bool
    {
        return trim($this->getElement('voucher_total')->getHtml()) === sprintf('-%s', $total);
    }

    public function isOrderTotalEqualTo($total): bool
    {
        return trim($this->getElement('order_total')->getHtml()) === $total;
    }

    public function removeVoucherWithCode($code)
    {
        sleep(1);

        $this->getDriver()->find(sprintf('.//a[@data-remove-voucher-code="%s"]', $code))[0]->click();
    }

    public function isVoucherTotalDisplayed(): bool
    {
        try {
            $this->getElement('voucher_total');

            return true;
        } catch (\Exception $e) {
            return false;
        }
    }

    protected function getDefinedElements(): array
    {
        return array_merge(parent::getDefinedElements(), [
            'voucher_radio' => '#dedi-sylius-voucher-add-voucher-to-order input[name="dedi_sylius_voucher_add_voucher_to_order[voucher]"]',
            'submit' => '#dedi-sylius-voucher-add-voucher-to-order button',
            'voucher_total' => '#exchange-total',
            'order_total' => '#sylius-summary-grand-total',
            'voucher_remove_code' => 'a[data-remove-voucher-code="%code%"]',
        ]);
    }
}
